<?php
	class libxml															
	{															
		private $curl = false, $fetchstart = 0, $fetchend = 0, $parsestart = 0, $parseend = 0, $xmlcharset = "";														
																
		function __construct() {														
			$this->curl = curl_init();													
		}														
		function __destruct() {														
			curl_close($this->curl);													
		}														
																
		// simple read and parse to array														
		function fetchTableFromXMLFileSimple($url, &$control)														
		{														
			$url = strip_tags($url);													
			$xml = $this->fetchfile($url);													
			if (strpos($xml, "/database") === false) return false;													
			return $this->parseresult($xml, $control);													
		}														
																
		function fetchfile($url) {														
			$file = '';													
			$this->fetchurl = $url;													
			$this->fetchstart = $this->microtime();													
			if (strtolower(substr($url, 0, 4)) == 'http') $file = $this->fetchremote($url);													
			else {													
				if (is_readable($url)) $file = file_get_contents($url);												
			}													
			$this->fetchend = $this->microtime();													
			return trim($file);													
		}														
																
		function fetchremote($url)														
		{														
			curl_setopt($this->curl, CURLOPT_TIMEOUT, 30);													
			curl_setopt($this->curl, CURLOPT_URL, $url);													
			curl_setopt($this->curl, CURLOPT_HEADER, 0);													
			curl_setopt($this->curl, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($this->curl, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
	  		curl_setopt($this->curl, CURLOPT_USERPWD, LOJZA.':'.LOJZA);	
			return curl_exec($this->curl);													
		}														
																
		function parseresult(&$xml, &$control)														
		{														
			// bez elemetu databaze se ani nesnaz													
			$pos = strpos($xml, "/database");													
			if ($pos === false) return false;													
																
			if($this->xmlcharset == ""){													
				ereg('encoding="([a-zA-Z0-9-]+)"', substr($xml, 0, 60), $x);												
				$this->xmlcharset = isset($x[1]) ? strtolower($x[1]) : false;												
			}													
																
			$array =& $this->parsetoarray($xml);													
																
			$result = array();													
			if ($array)													
			{													
				if (isset($array['control'])) $control = $array['control'];												
				else $array['control']['total_count'] =0;												
																
				if (!isset($array['control']['from_count']) || $array['control']['from_count'] < 1) $array['control']['from_count'] = 0;												
				if (!isset($array['control']['to_count'])) $array['control']['to_count'] = $array['control']['total_count'];												
																
				$result = array();												
				if (!empty($array['data']['row']) && is_array($array['data']['row']))												
				{												
					if (!isset($array['data']['row'][1]))											
					{											
						// 1 radek										
						$result = array($array['data']['row']);										
					}											
					else											
					{											
						// vic radku										
						$result =& $array['data']['row'];										
					}											
				}												
			}													
			return $result;													
		}														
																
		function &parsetoarray(&$xml)														
		{														
			$this->parsestart = $this->microtime();													
			$sxml = simplexml_load_string($xml);													
																
			$result = array();													
																
			if ($sxml === false)													
			return $result;													
																
			foreach ($sxml as $atomname => $atom)													
			{													
				$row = $this->parseatom($atom);												
				if ($row) $result[$atomname] = $row;												
			}													
			$this->parseend = $this->microtime();													
			return $result;													
		}														
																
		function parseatom(&$atom)														
		{														
			$return = array();													
			if (is_array($atom)) {													
				foreach ($atom as $key => $value)												
				$return[$key] = $this->parseatom($atom[$key]);												
			}													
																
			else													
			{													
				$var = get_object_vars($atom);												
				if ($var) {												
					foreach($var as $key => $value)											
					{											
						if ($key == 'images' || $key == 'xitems' || $key == 'videos' || $key == 'attachments')										
						{										
							$x = get_object_vars($value);									
							// print_r($x); die;									
							$data = $x['data'];									
							$x = get_object_vars($data);									
							if (empty($x['row'])) $value = array();									
							elseif (isset($x['row'][1])) $value = $x['row'];									
							else $value = array($x['row']);									
						}										
						$return[$key] = $this->parseatom($value);										
					}											
				}												
				else return trim((string) $atom);												
			}													
			return $return;													
		}														
																
		function showbenchmark() {														
			$this->endtime = $this->microtime();													
			return "XML fetched in ".round(($this->fetchend - $this->fetchstart)*1000, 4)."ms, parsed in ".round(($this->parseend - $this->parsestart)*1000, 4)."ms.\r\n\r\n";													
		}														
																
																
		function microtime() {														
			list($usec, $sec) = explode(" ", microtime());													
			return (float) $usec + (float) $sec;													
		}														
																
	}															
?>															
															
															
